(function(ionic){
    'use strict';
	
	angular.module('altacanApp').controller('DatosPersonalesCtrl', function($scope, $state, $http, md5, $ionicPopup, Token, Centros, Municipios, Login, UrlServiciosRest, TipoUsuario, $ionicConfig) { //$location,
		$ionicConfig.views.maxCache(0);
		
			if(localStorage.getItem(Token) !== null && localStorage.getItem(Token) !== ""){
				$state.go('menu');
			}

			$scope.showRegister = false;
			$scope.showLogin = false;
			$scope.showOptions = true;
			$scope.esperandoDP = false;
          
			$scope.login = {};
		  
			$scope.datos = {
				nombre : '',
				apellidos : '',
				email : '',
				clave: '',
				clave2: '',
				fecha : undefined,
				sexo : undefined,
				centro : undefined,
				clase : '',
				municipio : undefined,
				pais : '',
				marca : undefined,
				tipousuario : TipoUsuario
			};
			
			var hoy = new Date();
			hoy = hoy.getFullYear();
			var min = hoy - 17;
			$scope.minDate = min + "-01-01";
			var max = hoy - 11;
			$scope.maxDate = max + "-12-31";
			
			$scope.cargarCentrosMunicipios = 0;
						
			$scope.registrar = function() {
				if ($scope.cargarCentrosMunicipios == 0) {
					$scope.cargarCentrosMunicipios++;
					
					$scope.centros = Centros.query(function(data) {
						// success handler
					}, function(error) {
						console.error('ERR cargando institutos', JSON.stringify(error));
						$ionicPopup.alert({
							title: 'Error al obtener los centros.',
							template: 'Inténtelo más tarde.'
						});
					});
										
					$scope.municipios = Municipios.query(function(data) {
					}, function(error) {
						console.error('ERR cargando municipios', JSON.stringify(error));
						$ionicPopup.alert({
							title: 'Error al obtener los municipios.',
							template: 'Inténtelo más tarde.'
						});
					});
				}
				$scope.showRegister = true;
				$scope.showLogin = false;
				$scope.showOptions = false;
			};
			
			$scope.login = function() {
				$scope.showRegister = false;
				$scope.showLogin = true;
				$scope.showOptions = false;
			};
			
			$scope.volver = function() {
				$scope.showRegister = false;
				$scope.showLogin = false;
			};
						
			$scope.comprobarDatosLogin = function (formLogin) {
				if (formLogin.$valid) {
					$scope.esperandoDP = true;
						$http.put(UrlServiciosRest + 'usuario/login/' + $scope.login.email + '/' + $scope.login.psswd + '/' + TipoUsuario).then(function(resp) {
						var statusResp = resp.data.status;
						console.log("respuesta: " + statusResp);						
							if (statusResp == "ok" && resp.data.token != undefined) {
								localStorage.setItem(Token, resp.data.token);
								$state.go('menu');
							} else {
								$scope.esperandoDP = false;
								var msgError = resp.data.msg;
								$ionicPopup.alert({
									title: 'Error al acceder.',
									template: msgError
							    });
							}
					});
				}
			};
				
            $scope.comprobarDatosPersonales = function (form) {
				if (form.$valid) {									
					if ($scope.datos.clave != $scope.datos.clave2) {
						$ionicPopup.alert({
							title: 'Error',
							template: 'Las contraseñas no coinciden.'
						});
					} else {
						$scope.esperandoDP = true;	
						
						var token = Date.now() + $scope.datos.email.trim() + "Argos_74";
						$scope.datos.marca = md5.createHash(token);
						var oldCentro = $scope.datos.centro;
						$scope.datos.centro = $scope.datos.centro.id;
						var oldMunicipio = $scope.datos.municipio;
						$scope.datos.municipio = $scope.datos.municipio.id;
																
						$http.put(UrlServiciosRest + 'usuario/create/', $scope.datos).then(function(resp) {						
							// comprobar si ha ocurrido algún error en el proceso de registro
							console.log('registro', JSON.stringify(resp));
							var statusResp = resp.data.status;
							if (statusResp == "ok" && resp.data.token != undefined) {
								localStorage.setItem(Token, resp.data.token);
								$state.go('menu');
							} else {
								$scope.esperandoDP = false;	
								$scope.datos.centro = oldCentro;
								$scope.datos.municipio = oldMunicipio;
								var msgError = resp.data.msg;
								if (statusResp == 'warn') {							
									$ionicPopup.alert({
										title: 'No se ha podido registrar.',
										template: msgError
									});
								} else {
									$ionicPopup.alert({
										title: 'Error al registrarse.',
										template: msgError
									});
								}
							}										
						}, function(err) {
							$scope.esperandoDP = false;
							$scope.datos.centro = oldCentro;
							$scope.datos.municipio = oldMunicipio;
							console.error('ERR servicio rest de registro', JSON.stringify(err));
							$ionicPopup.alert({
								title: '',
								template: 'Ha ocurrido un error al conectar con el servidor.'
							});
						});
					}						
				}
            };
        })
})(window.ionic);