(function(ionic){
    'use strict';

	angular.module('altacanApp').controller('EncuestaCtrl',
		['$scope', '$state', '$http', '$ionicPopup', 'Token', 'UrlServiciosRest', '$stateParams', '$sce', 'Cuestionario', 'Preguntas', 'Solucion', 'TipoUsuario',
		function ($scope, $state, $http, $ionicPopup, Token, UrlServiciosRest, $stateParams, $sce, Cuestionario, Preguntas, Solucion, TipoUsuario) {
			//console.log("EncuestaCtrl");
			if(localStorage.getItem(Token) == null || localStorage.getItem(Token) == ""){
				$state.go("datosPersonales");
			}
			
			var token = localStorage.getItem(Token);
			
			if ($stateParams.ver == undefined) {
				$scope.readonly = 0;
			} else {
				$scope.readonly = $stateParams.ver;
			}
			$scope.showNote = 0;
			$scope.participa = '';
			$scope.color = $stateParams.color;
			$scope.canSave = 0;
			
			$scope.preguntas = [];
			
			$scope.esperando = true;
			
			if ($stateParams.idusuarioencuesta != undefined)  {
				// ya se ha realizado el cuestionario (esté en borrador o no)
				$scope.preguntasJson = Cuestionario.get({marca: token, tipousuario: TipoUsuario, id: $stateParams.idusuarioencuesta}, function(data) {					
					if ($stateParams.ver == "1" && $stateParams.encuestafinal == "1") {
						$scope.nota = $scope.preguntasJson.nota;
						$scope.showNote = 1;
						if ($scope.nota > 6) {
							$scope.participa = "¡Participas en el sorteo! Próximamente en tu Centro Educativo te darán el resultado.";
						}						
					}
					$scope.preguntas = $scope.preguntasJson.respuestas.map(function(o){ o.showmsginfo = false;  return o; });
					if ($scope.readonly == 0 && $scope.preguntas != undefined && $scope.preguntas.length > 0) {
						$scope.canSave = 1;
					}
				}, function(error) {
					console.error('ERR al recuperar el cuestionario', JSON.stringify(error));
					$ionicPopup.alert({
						title: 'Error al recuperar el cuestionario',
						template: 'Inténtelo más tarde.',
						buttons: [
						  {
							text: 'Volver al menú',
							type: 'button-positive',
							onTap: function(e) {
							  $state.go("menu");
							  window.location.reload(true);
							}
						  }
						]
					});
				});
			} else {
				$scope.preguntasJson = Preguntas.get({id: $stateParams.idencuesta}, function(resp) {
					if ($scope.preguntasJson.status == "ok") {											
						$scope.preguntasJson.preguntas.map(function(o) {
							$scope.preguntas.push({
								id: o.id,
								enunciado:  o.enunciado, 	//$sce.trustAsHtml(o.enunciado),
								valor: ''
							})
						});
						if ($scope.readonly == 0 && $scope.preguntas != undefined && $scope.preguntas.length > 0) {
							$scope.canSave = 1;
						}
					} else {
						$scope.readonly = 1;
						$ionicPopup.show({
							title: 'Error al recuperar las preguntas del cuestionario',
							template : $scope.preguntasJson.msg,
							buttons: [{
								text: 'Volver al menú',
								type: 'button-positive',
								onTap: function(e) {
								  $state.go("menu");
								  window.location.reload(true);
								}
							  }]
						});
					}
				});
			}
			
			$scope.esperando = false;
			if ($stateParams.encuestafinal == "1") {
				$scope.cabeceraEncuesta = "Cuestionario del Concurso.";						
			} else {
				$scope.cabeceraEncuesta = "Cuestionario. No te preocupes por las respuestas, te las van a explicar cuando vayas a tu Centro de Salud a realizar la 2ª Unidad Didáctica.";
			}
			
			
			$scope.enviarBorrador = function (form, borrador) {
				if (borrador == '0' && form.$invalid) {
					$ionicPopup.alert({
						title: 'No se ha podido enviar el cuestionario.',
						template: 'Debe contestar todas las preguntas.'
					});
				} else {
					$scope.esperando = true;
					var respuestasDadas = [];
					for (var pregunta of $scope.preguntas) {
						var respuesta = {
							id : pregunta.id,
							valor : pregunta.valor
						};
						respuestasDadas.push(respuesta);
					};
					var valoresJson = {
						borrador : borrador,
						id : $stateParams.idencuesta,
						pre : $stateParams.pre,
						respuestas : respuestasDadas
					};
					
					var url = UrlServiciosRest;
					if ($stateParams.idusuarioencuesta != undefined)  {
						url += 'cuestionario/editarcuestionario/' + token + '/' + TipoUsuario + '/' + $stateParams.idusuarioencuesta ;
					} else {
						url += 'cuestionario/crearcuestionario/' + token + '/' + TipoUsuario + '/' + $stateParams.idproceso ;
					}
					$http.put(url, valoresJson).then(function(respPunt) {
						// comprobar si ha ocurrido algún error en el proceso de registro
						var statusResp = respPunt.data.status;
						if (statusResp == "ok") {
							console.log('Encuesta enviada correctamente');
							var msg = '';
							if (borrador == 0 && valoresJson.pre == '0') {
								msg = 'Su puntuación es: <b>' + respPunt.data.nota + '</b>';
								if (respPunt.data.nota > 6) {
									msg += "¡Participas en el sorteo! Próximamente en tu Centro Educativo te darán el resultado.";
								}
							}
							$ionicPopup.show({
								title: 'Formulario enviado correctamente',
								template : msg,
								buttons: [
								  {
									text: 'Volver al menú',
									type: 'button-positive',
									onTap: function(e) {
									  $state.go("menu");
									  window.location.reload(true);
									}
								  }
								]
							});
							$scope.esperando = false;
						} else {
							var msgError = respPunt.data.msg;
							console.log('Error al guardar la encuesta: ' + msgError);
							$ionicPopup.alert({
								title: 'Error al guardar la encuesta.',
								template: msgError
							});							
						}										
					}, function(err) {
						console.error('ERR servicio rest de creación/edición de cuestionario', JSON.stringify(err));
						$ionicPopup.alert({
							title: '',
							template: 'Ha ocurrido un error al conectar con el servidor.'
						});
					});
				}
			}
			
			$scope.showhideinfofn = function(question) {
				if (question.showmsginfo == false) {
					if (question.solucion == undefined) {
						question.solucion = Solucion.get({id: $stateParams.idencuesta, idpregunta: question.id}, function(resp){question.solucion = $sce.trustAsHtml(resp.solucion); });							
					}
				};
				question.showmsginfo = !question.showmsginfo;
			}			
			
			$scope.goMenu = function() {
				$state.go("menu");				
			}		
		
		}])
})(window.ionic); 