(function(ionic){
    'use strict';
	
	angular.module('altacanApp').controller('MenuCtrl', 
		['$scope', '$state', '$http', '$ionicPopup', '$sce', 'Token', 'UrlServiciosRest', 'TipoUsuario',
		function ($scope, $state, $http, $ionicPopup, $sce, Token, UrlServiciosRest, TipoUsuario) {
			if(localStorage.getItem(Token) == null || localStorage.getItem(Token) == ""){
				$state.go("datosPersonales");
			}
			var marca = localStorage.getItem(Token);
			//console.log(marca);
			
			$scope.encuestas =  [];
			
			$scope.cuestionarioid = '';
			
			$scope.imagenes = ['circulo3.png', 'circulo4.png', 'circulo2.png'];
			
			$scope.msgVerSoluciones = 'No disponible';
			
			var url = UrlServiciosRest + 'cuestionario/todos/' + marca + '/' + TipoUsuario;
			$http.get(url).then(function(resp) {
				// recibe json --> procesoscuestionarios {orden; nombre; descripcion; final; cuestionarios: {id; nombre; borrador; nota; idusuarioencuesta}}
				var statusResp = resp.data.status;
					
				if (statusResp == "ok") {
					var encuestaAnterior = '';
					resp.data.procesoscuestionarios.map(function(o, index) {
						// voy a suponer que sólo hay 1 cuestionario x proceso
							var encuesta = {
								idencuesta: '',
								idproceso: o.id,
								idusuarioencuesta: '',
								texto: o.nombre,
								descripcion: $sce.trustAsHtml(o.descripcion),
								icon: '',
								img: 'img/' + $scope.imagenes[(index)%3],
								ver: 0,
								msg: '',
								disponible: 1,
								color: index % 2 == 0 ? 'rojo' : 'azul', 
								encfinal: o.final ? 1 : 0
							};
							
							var cuest = o.cuestionarios[0];
							encuesta.idencuesta = cuest.id;
							encuesta.idusuarioencuesta = cuest.idusuarioencuesta;
							if (cuest.borrador == undefined) {
								encuesta.msg = "Realizar";
								encuesta.icon = 'ion-edit';
							} else {
								if (cuest.borrador == "1") {
									encuesta.msg = "Editar";
									encuesta.icon = 'ion-compose';
								} else {
									encuesta.ver = 1;
									encuesta.icon = 'ion-search';
									if (o.final == "1") {
										$scope.msgVerSoluciones = 'Ver';
										encuesta.msg = "Ver (puntuación: " + cuest.nota + ")";
										$scope.cuestionarioid = cuest.id;
									} else {
										encuesta.msg = "Ver";
									}
								}
							}
							if (encuestaAnterior.ver == 0) {
								// no se puede realizar hasta que la encuesta anterior no está confirmada
								encuesta.disponible = 0;
								encuesta.msg = 'No disponible';
								encuesta.icon = 'ion-close-circled';
							}
							encuestaAnterior = encuesta;
							$scope.encuestas.push(encuesta);
						});
					
				} else {
					$ionicPopup.alert({
						title: 'Error al obtener información de las encuestas.',
						template: resp.data.msg
					});
				}
			}, function(err) {
				console.error('ERR consultando existencia de encuestas', JSON.stringify(err));
				$ionicPopup.alert({
					title: 'Error al obtener información de las encuestas.',
					template: 'Inténtelo más tarde.'
				});
			})
		
		
			$scope.goEncuesta = function(indexEncuesta) {
				var encuesta = $scope.encuestas[indexEncuesta];
				//console.log(JSON.stringify(encuesta));
				if (encuesta.disponible == 1) {
					if (encuesta.idusuarioencuesta != undefined) {
						$state.go("encuesta", {idusuarioencuesta: encuesta.idusuarioencuesta, idencuesta: encuesta.idencuesta, ver: encuesta.ver, encuestafinal: encuesta.encfinal , color: encuesta.color});
					} else {
						$state.go("encuestanueva", {idencuesta: encuesta.idencuesta, idproceso: encuesta.idproceso, color: encuesta.color});
					}
				}				
			}

			$scope.goSoluciones = function() {
				if ($scope.msgVerSoluciones == 'Ver') {
					$state.go("soluciones", {idencuesta: $scope.cuestionarioid});
				}
			}
		}])
})(window.ionic);