var dependencias = ['ionic', 'ngAnimate', 'ngMessages', 'ui.router', 'ui.bootstrap', 'angular-md5', 'altacanApp.services', 'ngCordova'];

angular.module('altacanApp', dependencias)

		.run(function ($ionicPlatform) {
			$ionicPlatform.ready(function () {
				// Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
				// for form inputs)
				if (window.cordova && window.cordova.plugins.Keyboard) {
					cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
				}

				if (window.StatusBar) {
					// org.apache.cordova.statusbar required
					StatusBar.styleDefault();
				}

			});
		})
		
		.config(['$httpProvider', function($httpProvider) {
			//Enable cross domain calls
			$httpProvider.defaults.useXDomain = true;
			$httpProvider.defaults.headers.post["Content-Type"] = "application/json;charset=utf-8";
			//$httpProvider.defaults.headers.post["Content-Type"] = "application/x-www-form-urlencoded";
			//$httpProvider.defaults.headers.common = {};
			//$httpProvider.defaults.headers.post = {};
		}])
        
		.config(['$stateProvider', '$urlRouterProvider', function ($stateProvider, $urlRouterProvider) {
			//$ionicConfigProvider.views.maxCache(0);
			
            $stateProvider
				.state('bases', {
					url: '/bases',
					templateUrl: 'templates/bases.html',
					controller: 'BasesCtrl'
				})
				.state('datosPersonales', {
					cache: false,
					url: '/datos_personales',
					templateUrl: 'templates/datos_personales.html',
					controller: 'DatosPersonalesCtrl'
				})
				.state('menu', {
					cache: false,
					url: '/menu',
					templateUrl: 'templates/menu.html',
					controller: "MenuCtrl"
				})
				.state('encuesta', {
					url: '/encuesta/:idusuarioencuesta/:idencuesta/:ver/:encuestafinal/:color',
					templateUrl: 'templates/encuesta.html',
					controller: 'EncuestaCtrl'
				})
				.state('encuestanueva', {
					url: '/encuesta/:idencuesta/:idproceso/:color',
					templateUrl: 'templates/encuesta.html',
					controller: 'EncuestaCtrl'
				})
				.state('soluciones', {
					url: '/soluciones/:idencuesta',
					templateUrl: 'templates/soluciones.html',
					controller: 'SolucionesCtrl'
				})
            $urlRouterProvider.otherwise('/datos_personales');
        }])
		
		.directive('preguntavf', function() {			
			return {
				restrict: 'E',
				scope: {
					datospregunta: "=",
					idx: '=',
					readonly: "=",
					color: "=",
					showiconinfo: "=",
					showhideinfo: "="
				},
				templateUrl: 'templates/preguntaVF.html'
			};
		})
		
		.directive('header', function() {
			return {
				restrict: 'A',
				replace: true,
				templateUrl: 'templates/header.html'
			}
		})
		
		
		
